/*
 * Copyright (c) 1996 Andrew Main.  All rights reserved.
 *
 * Redistribution and use, in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer
 *    in the documentation and/or other materials provided with the
 *    distribution.
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgement:
 *        This product includes software developed by Andrew Main.
 * 4. The name of Andrew Main may not be used to endorse or promote
 *    products derived from this software without specific prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL ANDREW MAIN BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <asm/unistd.h>

.text
.globl _start
_start:
	popl %edx			/* argc */
	cmpl $3, %edx
	jne 1f
#ifndef __ELF__
	popl %eax			/* argv */
	popl %ecx			/* envp */
#endif
	popl %eax			/* argv[0] */
	popl %ecx			/* argv[1] */
	popl %ebx			/* argv[2] */
	movl $__NR_unlink, %eax
	int $0x80			/* unlink(argv[2]) */
	xchgl %ebx, %ecx
	movl $__NR_symlink, %eax
	int $0x80			/* symlink(argv[1], argv[2]) */
	shrl $31, %eax
	movl %eax, %ebx
	movl $__NR_exit, %eax
	int $0x80			/* _exit(0) or _exit(1) */
1:	
	movl $__NR_exit, %eax
	xorl %ebx, %ebx
	movb $2, %bl
	int $0x80			/* _exit(2) */
